'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('io-client/muutio');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var muutIO = function muutIO(params) {
  return function (WrappedComponent) {
    var NewComponent = function (_Component) {
      _inherits(NewComponent, _Component);

      function NewComponent(props) {
        _classCallCheck(this, NewComponent);

        var _this = _possibleConstructorReturn(this, (NewComponent.__proto__ || Object.getPrototypeOf(NewComponent)).call(this, props));

        _this.state = { isLoaded: false, data: {} };
        var self = _this;
        window.muutio(params, function (data) {
          self.setState({ isLoaded: true, api: this, data: data });
        });
        return _this;
      }

      _createClass(NewComponent, [{
        key: 'render',
        value: function render() {
          var _state = this.state,
              isLoaded = _state.isLoaded,
              api = _state.api,
              data = _state.data;

          return _react2.default.createElement(WrappedComponent, { data: data, api: api, isLoaded: isLoaded });
        }
      }]);

      return NewComponent;
    }(_react.Component);

    return function () {
      return _react2.default.createElement(NewComponent, null);
    };
  };
};

exports.default = muutIO;